<?php

/**
 * extracto_consol_anual actions.
 *
 * @package    nomina
 * @subpackage extracto_consol_anual
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class extracto_consol_anualActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = 'order by ID_PERIODO , ID_TIPO_DOC , NUM_DOC';
        }


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $periodo_filtro = $request['id_periodo_filtro'];
            $periodo = $request['id_periodo'];

            /*
             * Variables opcionales
             */
            //funcionario
            if (isset($request['num_doc'])) {
                $whereFuncionarioNumDoc = " AND tab0.num_doc = " . $request['num_doc'];
            } else {
                $whereFuncionarioNumDoc = ' ';
            }
            //funcionario
            if (isset($request['id_tipo_doc'])) {
                $whereFuncionarioTipoDoc = " AND tab0.id_tipo_doc = " . $request['id_tipo_doc'];
            } else {
                $whereFuncionarioTipoDoc = ' ';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (
    
select   
TAB0.ID_CESANTIA as ID_CESANTIA, TAB0.ID_PERIODO as ID_PERIODO, TAB0.ID_TIPO_DOC as ID_TIPO_DOC, 
TAB0.NUM_DOC as NUM_DOC, TAB0.ID_CONCEP_NOMINA as ID_CONCEP_NOMINA, TAB0.VALOR_LIQUIDADO as VALOR_LIQUIDADO, 
TAB0.NUM_DIAS as NUM_DIAS, 
TAB0.VALOR_BASE as VALOR_BASE, 
TAB0.VALOR_CONSOLIDADO as VALOR_CONSOLIDADO, TAB0.VALOR_APLICADO as VALOR_APLICADO, 
TAB0.VALOR_AJUSTE as VALOR_AJUSTE, TAB1.DESCRIPCION as DESCRIPCION, TAB1.ABREVIACION as ABREVIACION, 
TAB2.PRIMER_NOMBRE as PRIMER_NOMBRE, TAB2.SEGUNDO_NOMBRE as SEGUNDO_NOMBRE, 
TAB2.PRIMER_APELLIDO as PRIMER_APELLIDO, TAB2.SEGUNDO_APELLIDO as SEGUNDO_APELLIDO, 
TAB2.PRIMER_NOMBRE||' '||TAB2.SEGUNDO_NOMBRE as NOMBRE, 
translate(tab2.nombre_apellido,'áéíóúÁÉÍÓÚñÑ','aeiouAEIOUnN') nombre_apellido,
tab2.email,
tab3.periodo,
TAB3.ID_ANHOS as ID_ANHOS, 
TAB3.ID_MESES as ID_MESES, TAB3.ID_ANHOS||' '||TAB3.ID_MESES as PERIODO_MES, 
TAB4.ASIGNACION_BASICA as ASIGNACION_BASICA, TAB8.CODDEPTO as CODDEPTO, TAB9.CODMUN_TEXT as CODMUN_TEXT,
tab10.fecha_ingreso, tab10.fecha_termina, tab10.fecha_retiro

from NO_CESANTIA tab0  

join TIPO_DOCUMENTO TAB1 on TAB0.ID_TIPO_DOC = TAB1.ID_TIPO_DOC  
JOIN NO_DATOS_FUNCIONARIO_V tab2 ON tAB0.ID_TIPO_DOC = TAB2.ID_TIPO_DOC and TAB0.NUM_DOC = TAB2.NUM_DOC  
join NO_PERIODO_V TAB3 on TAB0.ID_PERIODO = TAB3.ID_PERIODO  
LEFT JOIN NO_LIQUIDA_V tab4 ON tab0.id_tipo_doc = tab4.id_tipo_dOC and TAB0.NUM_DOC = TAB4.NUM_DOC and TAB0.ID_PERIODO = TAB4.ID_PERIODO  
left join NO_ESTADO_FUNC_V TAB5 on TAB0.ID_TIPO_DOC = TAB5.ID_TIPO_DOC and TAB0.NUM_DOC = TAB5.NUM_DOC and TAB0.ID_PERIODO = TAB5.PERIODO
left join no_nombramiento_v tab10 ON tab10.id_tipo_doc = tab0.id_tipo_doc and tab10.num_doc = tab0.num_doc 
--and tab10.id_dp = tab5.id_dp
left join NO_DP_V TAB6 on TAB5.ID_DP = TAB6.ID_DP  
left join CENTRO_OPERACION TAB7 on TAB5.ID_CEN_OP = TAB7.ID_CEN_OP  left join DEPARTAMENTO TAB8 on TAB7.ID_DEPTO = TAB8.ID_DEPTO  
left join MUNICIPIOS TAB9 on TAB7.CODMUN = TAB9.CODMUN 

where 
tab0.id_periodo = $periodo_filtro and tab0.CONSOLIDADO = 1
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc
    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

select   
TAB0.ID_CESANTIA as ID_CESANTIA, TAB0.ID_PERIODO as ID_PERIODO, TAB0.ID_TIPO_DOC as ID_TIPO_DOC, 
TAB0.NUM_DOC as NUM_DOC, TAB0.ID_CONCEP_NOMINA as ID_CONCEP_NOMINA, TAB0.VALOR_LIQUIDADO as VALOR_LIQUIDADO, 
TAB0.NUM_DIAS as NUM_DIAS, 
TAB0.VALOR_BASE as VALOR_BASE, 
TAB0.VALOR_CONSOLIDADO as VALOR_CONSOLIDADO, TAB0.VALOR_APLICADO as VALOR_APLICADO, 
TAB0.VALOR_AJUSTE as VALOR_AJUSTE, TAB1.DESCRIPCION as DESCRIPCION, TAB1.ABREVIACION as ABREVIACION, 
TAB2.PRIMER_NOMBRE as PRIMER_NOMBRE, TAB2.SEGUNDO_NOMBRE as SEGUNDO_NOMBRE, 
TAB2.PRIMER_APELLIDO as PRIMER_APELLIDO, TAB2.SEGUNDO_APELLIDO as SEGUNDO_APELLIDO, 
TAB2.PRIMER_NOMBRE||' '||TAB2.SEGUNDO_NOMBRE as NOMBRE, 
translate(tab2.nombre_apellido,'áéíóúÁÉÍÓÚñÑ','aeiouAEIOUnN') nombre_apellido,
tab2.email,
tab3.periodo,
TAB3.ID_ANHOS as ID_ANHOS, 
TAB3.ID_MESES as ID_MESES, TAB3.ID_ANHOS||' '||TAB3.ID_MESES as PERIODO_MES, 
TAB4.ASIGNACION_BASICA as ASIGNACION_BASICA, TAB8.CODDEPTO as CODDEPTO, TAB9.CODMUN_TEXT as CODMUN_TEXT,
tab10.fecha_ingreso, tab10.fecha_termina, tab10.fecha_retiro

from NO_CESANTIA tab0  

join TIPO_DOCUMENTO TAB1 on TAB0.ID_TIPO_DOC = TAB1.ID_TIPO_DOC  
JOIN NO_DATOS_FUNCIONARIO_V tab2 ON tAB0.ID_TIPO_DOC = TAB2.ID_TIPO_DOC and TAB0.NUM_DOC = TAB2.NUM_DOC  
join NO_PERIODO_V TAB3 on TAB0.ID_PERIODO = TAB3.ID_PERIODO  
LEFT JOIN NO_LIQUIDA_V tab4 ON tab0.id_tipo_doc = tab4.id_tipo_dOC and TAB0.NUM_DOC = TAB4.NUM_DOC and TAB0.ID_PERIODO = TAB4.ID_PERIODO  
left join NO_ESTADO_FUNC_V TAB5 on TAB0.ID_TIPO_DOC = TAB5.ID_TIPO_DOC and TAB0.NUM_DOC = TAB5.NUM_DOC and TAB0.ID_PERIODO = TAB5.PERIODO
left join no_nombramiento_v tab10 ON tab10.id_tipo_doc = tab0.id_tipo_doc and tab10.num_doc = tab0.num_doc 
--and tab10.id_dp = tab5.id_dp
left join NO_DP_V TAB6 on TAB5.ID_DP = TAB6.ID_DP  
left join CENTRO_OPERACION TAB7 on TAB5.ID_CEN_OP = TAB7.ID_CEN_OP  left join DEPARTAMENTO TAB8 on TAB7.ID_DEPTO = TAB8.ID_DEPTO  
left join MUNICIPIOS TAB9 on TAB7.CODMUN = TAB9.CODMUN 

where 
tab0.id_periodo = $periodo_filtro and tab0.CONSOLIDADO = 1
$whereFuncionarioNumDoc
$whereFuncionarioTipoDoc

$sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[extracto_consol_anual] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
